
(* SPAN - A Security Protocol Animator
   Copyright (C) 2006-2009 Yann Glouche, Thomas Genet, Olivier Heen, 
   	     	 	   Erwan Houssay and Ronan Saillard.

   The CAS+ Parser includes source code from the CASRUL tool
   CASRUL: Copyright (C) 2001 Florent Jacquemard, Michael Rusinowitch and
      		    	      Laurent Vigneron.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU Library General Public License version 2, as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   See the GNU Library General Public License version 2 for more details
   (enclosed in the file LGPL).


   Version 1.6. Last modification 16/07/09
*)
type token =
  | SUMMARY
  | SAFE
  | UNSAFE
  | INCONCLUSIVE
  | DETAILS
  | ATTACK_FOUND
  | STRONGLY_TYPED_MODEL
  | TYPED_MODEL
  | UNTYPED_MODEL
  | BOUNDED_NUMBER_OF_SESSIONS
  | BOUNDED_NUMBER_OF_SYMBOLIC_SESSIONS
  | BOUNDED_SEARCH_DEPTH
  | BOUNDED_MESSAGE_DEPTH
  | TIME_OUT
  | MEMORY_OUT
  | NOT_SUPPORTED
  | OVER_APPROXIMATION
  | UNDER_APPROXIMATION
  | ATTACK_TRACE
  | IDENT of (string)
  | ROLE of (string)
  | NUMBER of (int)
  | AGENT of (string*int)
  | NONCE_ATSE of (string*int)
  | NONCE_OFMC of (string*int)
  | FREE_ATSE of (string*int)
  | FREE_OFMC of (string*int)
  | PROP
  | START
  | EMPTY
  | ARROW
  | COLON
  | L_ROUND
  | R_ROUND
  | L_CURLY
  | R_CURLY
  | DOT
  | UNDERSCORE
  | COMMA
  | EOF

open Parsing;;
# 8 "atkifparser.mly"
(* Provides access to semantic analysis tools for attack trace generation *)
open Semantics;;
# 48 "atkifparser.ml"
let yytransl_const = [|
  257 (* SUMMARY *);
  258 (* SAFE *);
  259 (* UNSAFE *);
  260 (* INCONCLUSIVE *);
  261 (* DETAILS *);
  262 (* ATTACK_FOUND *);
  263 (* STRONGLY_TYPED_MODEL *);
  264 (* TYPED_MODEL *);
  265 (* UNTYPED_MODEL *);
  266 (* BOUNDED_NUMBER_OF_SESSIONS *);
  267 (* BOUNDED_NUMBER_OF_SYMBOLIC_SESSIONS *);
  268 (* BOUNDED_SEARCH_DEPTH *);
  269 (* BOUNDED_MESSAGE_DEPTH *);
  270 (* TIME_OUT *);
  271 (* MEMORY_OUT *);
  272 (* NOT_SUPPORTED *);
  273 (* OVER_APPROXIMATION *);
  274 (* UNDER_APPROXIMATION *);
  275 (* ATTACK_TRACE *);
  284 (* PROP *);
  285 (* START *);
  286 (* EMPTY *);
  287 (* ARROW *);
  288 (* COLON *);
  289 (* L_ROUND *);
  290 (* R_ROUND *);
  291 (* L_CURLY *);
  292 (* R_CURLY *);
  293 (* DOT *);
  294 (* UNDERSCORE *);
  295 (* COMMA *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  276 (* IDENT *);
  277 (* ROLE *);
  278 (* NUMBER *);
  279 (* AGENT *);
  280 (* NONCE_ATSE *);
  281 (* NONCE_OFMC *);
  282 (* FREE_ATSE *);
  283 (* FREE_OFMC *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\004\000\004\000\005\000\005\000\007\000\
\009\000\009\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\006\000\010\000\012\000\012\000\011\000\011\000\
\011\000\011\000\011\000\003\000\003\000\014\000\014\000\013\000\
\015\000\015\000\016\000\019\000\019\000\018\000\018\000\017\000\
\017\000\020\000\020\000\021\000\023\000\023\000\022\000\022\000\
\025\000\025\000\025\000\025\000\025\000\026\000\026\000\027\000\
\027\000\024\000\024\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\001\000\001\000\002\000\002\000\003\000\
\002\000\000\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\002\000\003\000\002\000\000\000\001\000\001\000\
\001\000\001\000\001\000\003\000\000\000\002\000\000\000\004\000\
\002\000\000\000\004\000\001\000\001\000\001\000\000\000\001\000\
\001\000\001\000\001\000\002\000\003\000\000\000\005\000\001\000\
\002\000\001\000\001\000\001\000\001\000\004\000\000\000\003\000\
\000\000\001\000\003\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\060\000\000\000\000\000\000\000\000\000\
\003\000\004\000\005\000\000\000\001\000\000\000\006\000\007\000\
\000\000\019\000\000\000\000\000\000\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\000\000\023\000\024\000\
\025\000\026\000\027\000\000\000\033\000\000\000\028\000\037\000\
\036\000\000\000\000\000\000\000\008\000\000\000\020\000\030\000\
\000\000\050\000\052\000\051\000\053\000\042\000\043\000\000\000\
\000\000\040\000\041\000\000\000\048\000\000\000\009\000\021\000\
\000\000\049\000\000\000\038\000\032\000\000\000\044\000\000\000\
\000\000\000\000\000\000\035\000\000\000\000\000\000\000\045\000\
\000\000\054\000\000\000\047\000\058\000\056\000\000\000\059\000"

let yydgoto = "\002\000\
\004\000\005\000\013\000\009\000\010\000\011\000\015\000\044\000\
\045\000\018\000\046\000\047\000\038\000\039\000\021\000\042\000\
\057\000\069\000\043\000\058\000\059\000\060\000\071\000\084\000\
\061\000\066\000\078\000"

let yysindex = "\012\000\
\001\255\000\000\056\255\000\000\241\254\003\255\003\255\007\255\
\000\000\000\000\000\000\240\254\000\000\044\255\000\000\000\000\
\030\255\000\000\237\254\240\254\012\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\044\255\000\000\000\000\
\000\000\000\000\000\000\030\255\000\000\240\254\000\000\000\000\
\000\000\246\254\247\254\044\255\000\000\030\255\000\000\000\000\
\249\254\000\000\000\000\000\000\000\000\000\000\000\000\004\255\
\005\255\000\000\000\000\024\255\000\000\012\255\000\000\000\000\
\004\255\000\000\002\255\000\000\000\000\004\255\000\000\031\255\
\023\255\026\255\024\255\000\000\004\255\032\255\016\255\000\000\
\023\255\000\000\004\255\000\000\000\000\000\000\033\255\000\000"

let yyrindex = "\000\000\
\065\000\000\000\000\000\000\000\068\000\000\000\000\000\000\000\
\000\000\000\000\000\000\014\255\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\011\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\003\000\000\000\000\000\
\000\000\000\000\000\000\007\000\000\000\011\000\000\000\000\000\
\000\000\000\000\000\000\003\000\000\000\007\000\000\000\000\000\
\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\023\000\000\000\000\000\005\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\035\255\000\000\005\000\000\000\000\000\000\000\000\000\000\000\
\035\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\063\000\057\000\
\028\000\000\000\056\000\029\000\062\000\038\000\000\000\000\000\
\000\000\000\000\015\000\000\000\200\255\008\000\004\000\000\000\
\002\000\000\000\255\255"

let yytablesize = 302
let yytable = "\067\000\
\055\000\003\000\010\000\012\000\046\000\019\000\022\000\014\000\
\073\000\049\000\031\000\017\000\001\000\050\000\051\000\052\000\
\053\000\037\000\054\000\055\000\081\000\062\000\039\000\049\000\
\056\000\065\000\087\000\050\000\051\000\052\000\053\000\040\000\
\068\000\034\000\041\000\049\000\034\000\074\000\056\000\050\000\
\051\000\052\000\053\000\031\000\032\000\033\000\034\000\035\000\
\083\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\006\000\007\000\008\000\070\000\077\000\076\000\079\000\
\002\000\082\000\088\000\029\000\057\000\016\000\030\000\063\000\
\036\000\020\000\064\000\048\000\072\000\075\000\080\000\086\000\
\085\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\055\000\010\000\055\000\055\000\
\046\000\022\000\046\000\046\000\055\000\000\000\034\000\000\000\
\046\000\034\000\055\000\000\000\055\000\055\000\046\000\055\000\
\046\000\000\000\039\000\046\000\039\000\039\000"

let yycheck = "\056\000\
\000\000\001\001\000\000\019\001\000\000\022\001\000\000\005\001\
\065\000\020\001\000\000\005\001\001\000\024\001\025\001\026\001\
\027\001\037\001\029\001\030\001\077\000\031\001\000\000\020\001\
\035\001\033\001\083\000\024\001\025\001\026\001\027\001\020\001\
\028\001\020\001\023\001\020\001\023\001\036\001\035\001\024\001\
\025\001\026\001\027\001\014\001\015\001\016\001\017\001\018\001\
\033\001\006\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\002\001\003\001\004\001\037\001\039\001\032\001\038\001\
\000\000\034\001\034\001\000\000\034\001\007\000\014\000\044\000\
\017\000\012\000\046\000\038\000\062\000\070\000\075\000\081\000\
\079\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\020\001\019\001\022\001\023\001\
\020\001\019\001\022\001\023\001\028\001\255\255\020\001\255\255\
\028\001\023\001\034\001\255\255\036\001\037\001\034\001\039\001\
\036\001\255\255\020\001\039\001\022\001\023\001"

let yynames_const = "\
  SUMMARY\000\
  SAFE\000\
  UNSAFE\000\
  INCONCLUSIVE\000\
  DETAILS\000\
  ATTACK_FOUND\000\
  STRONGLY_TYPED_MODEL\000\
  TYPED_MODEL\000\
  UNTYPED_MODEL\000\
  BOUNDED_NUMBER_OF_SESSIONS\000\
  BOUNDED_NUMBER_OF_SYMBOLIC_SESSIONS\000\
  BOUNDED_SEARCH_DEPTH\000\
  BOUNDED_MESSAGE_DEPTH\000\
  TIME_OUT\000\
  MEMORY_OUT\000\
  NOT_SUPPORTED\000\
  OVER_APPROXIMATION\000\
  UNDER_APPROXIMATION\000\
  ATTACK_TRACE\000\
  PROP\000\
  START\000\
  EMPTY\000\
  ARROW\000\
  COLON\000\
  L_ROUND\000\
  R_ROUND\000\
  L_CURLY\000\
  R_CURLY\000\
  DOT\000\
  UNDERSCORE\000\
  COMMA\000\
  EOF\000\
  "

let yynames_block = "\
  IDENT\000\
  ROLE\000\
  NUMBER\000\
  AGENT\000\
  NONCE_ATSE\000\
  NONCE_OFMC\000\
  FREE_ATSE\000\
  FREE_OFMC\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'summary) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attack_trace) in
    Obj.repr(
# 42 "atkifparser.mly"
                      ( (if !dbg_mode then (print_debug _2 ; dbg_mode := false)) ; parsing_reset() ; _2 )
# 301 "atkifparser.ml"
               : string))
; (fun __caml_parser_env ->
    Obj.repr(
# 43 "atkifparser.mly"
     ( (if !dbg_mode then (print_debug "NONE" ; dbg_mode := false)) ; parsing_reset() ; "" )
# 307 "atkifparser.ml"
               : string))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'result) in
    Obj.repr(
# 49 "atkifparser.mly"
                (  )
# 314 "atkifparser.ml"
               : 'summary))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'conclusive) in
    Obj.repr(
# 53 "atkifparser.mly"
            (  )
# 321 "atkifparser.ml"
               : 'result))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'inconclusive) in
    Obj.repr(
# 54 "atkifparser.mly"
               (  )
# 328 "atkifparser.ml"
               : 'result))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'conclusive_details) in
    Obj.repr(
# 58 "atkifparser.mly"
                          ( raise Not_unsafe )
# 335 "atkifparser.ml"
               : 'conclusive))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'conclusive_details) in
    Obj.repr(
# 59 "atkifparser.mly"
                            ( if not _2 then raise No_attack_found )
# 342 "atkifparser.ml"
               : 'conclusive))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'conclusive_explanation) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'more_conclusive_explanation) in
    Obj.repr(
# 63 "atkifparser.mly"
                                                            ( _2 or _3 )
# 350 "atkifparser.ml"
               : 'conclusive_details))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'conclusive_explanation) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'more_conclusive_explanation) in
    Obj.repr(
# 67 "atkifparser.mly"
                                                    ( _1 or _2 )
# 358 "atkifparser.ml"
               : 'more_conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 68 "atkifparser.mly"
         ( false )
# 364 "atkifparser.ml"
               : 'more_conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 72 "atkifparser.mly"
                 ( true )
# 370 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 73 "atkifparser.mly"
                         ( false )
# 376 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 74 "atkifparser.mly"
                 ( false )
# 382 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 75 "atkifparser.mly"
                   ( false )
# 388 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 76 "atkifparser.mly"
                              ( false )
# 394 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 77 "atkifparser.mly"
                                      ( false )
# 400 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 78 "atkifparser.mly"
                         ( false )
# 406 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 79 "atkifparser.mly"
                          ( false )
# 412 "atkifparser.ml"
               : 'conclusive_explanation))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'inconclusive_details) in
    Obj.repr(
# 83 "atkifparser.mly"
                                   ( raise Not_unsafe )
# 419 "atkifparser.ml"
               : 'inconclusive))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'inconclusive_explanation) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'more_inconclusive_explanation) in
    Obj.repr(
# 87 "atkifparser.mly"
                                                                (  )
# 427 "atkifparser.ml"
               : 'inconclusive_details))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'inconclusive_explanation) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'more_inconclusive_explanation) in
    Obj.repr(
# 91 "atkifparser.mly"
                                                        (  )
# 435 "atkifparser.ml"
               : 'more_inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 92 "atkifparser.mly"
         (  )
# 441 "atkifparser.ml"
               : 'more_inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 96 "atkifparser.mly"
           (  )
# 447 "atkifparser.ml"
               : 'inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 97 "atkifparser.mly"
              (  )
# 453 "atkifparser.ml"
               : 'inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 98 "atkifparser.mly"
                 (  )
# 459 "atkifparser.ml"
               : 'inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 99 "atkifparser.mly"
                     (  )
# 465 "atkifparser.ml"
               : 'inconclusive_explanation))
; (fun __caml_parser_env ->
    Obj.repr(
# 100 "atkifparser.mly"
                      (  )
# 471 "atkifparser.ml"
               : 'inconclusive_explanation))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'step) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'more_step) in
    Obj.repr(
# 106 "atkifparser.mly"
                              ( _2^_3 )
# 479 "atkifparser.ml"
               : 'attack_trace))
; (fun __caml_parser_env ->
    Obj.repr(
# 107 "atkifparser.mly"
      ( "" )
# 485 "atkifparser.ml"
               : 'attack_trace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'step) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'more_step) in
    Obj.repr(
# 111 "atkifparser.mly"
                ( _1^_2 )
# 493 "atkifparser.ml"
               : 'more_step))
; (fun __caml_parser_env ->
    Obj.repr(
# 112 "atkifparser.mly"
    ( "\n" )
# 499 "atkifparser.ml"
               : 'more_step))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'maybe_step_number) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'agents) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'message) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'maybe_properties) in
    Obj.repr(
# 116 "atkifparser.mly"
                                                   ( string_of_step _2 _3 )
# 509 "atkifparser.ml"
               : 'step))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : int) in
    Obj.repr(
# 120 "atkifparser.mly"
            (  )
# 516 "atkifparser.ml"
               : 'maybe_step_number))
; (fun __caml_parser_env ->
    Obj.repr(
# 121 "atkifparser.mly"
    (  )
# 522 "atkifparser.ml"
               : 'maybe_step_number))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'agent) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'agent) in
    Obj.repr(
# 125 "atkifparser.mly"
                         ( string_of_agents _1 _3 )
# 530 "atkifparser.ml"
               : 'agents))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string*int) in
    Obj.repr(
# 129 "atkifparser.mly"
       ( _1 )
# 537 "atkifparser.ml"
               : 'agent))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 130 "atkifparser.mly"
        ( match _1 with "i" -> ("i",0) | _ -> raise Parsing.Parse_error )
# 544 "atkifparser.ml"
               : 'agent))
; (fun __caml_parser_env ->
    Obj.repr(
# 134 "atkifparser.mly"
      (  )
# 550 "atkifparser.ml"
               : 'maybe_properties))
; (fun __caml_parser_env ->
    Obj.repr(
# 135 "atkifparser.mly"
   (  )
# 556 "atkifparser.ml"
               : 'maybe_properties))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'specific) in
    Obj.repr(
# 139 "atkifparser.mly"
          ( _1 )
# 563 "atkifparser.ml"
               : 'message))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'general) in
    Obj.repr(
# 140 "atkifparser.mly"
           ( _1 )
# 570 "atkifparser.ml"
               : 'message))
; (fun __caml_parser_env ->
    Obj.repr(
# 144 "atkifparser.mly"
       ( SPECIFIC )
# 576 "atkifparser.ml"
               : 'specific))
; (fun __caml_parser_env ->
    Obj.repr(
# 145 "atkifparser.mly"
        ( SPECIFIC )
# 582 "atkifparser.ml"
               : 'specific))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'maybe_ciphered) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'maybe_paired) in
    Obj.repr(
# 149 "atkifparser.mly"
                             ( GENERAL (string_of_paired _1 _2) )
# 590 "atkifparser.ml"
               : 'general))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'maybe_ciphered) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'maybe_paired) in
    Obj.repr(
# 153 "atkifparser.mly"
                                 ( PAIRED (string_of_paired _2 _3) )
# 598 "atkifparser.ml"
               : 'maybe_paired))
; (fun __caml_parser_env ->
    Obj.repr(
# 154 "atkifparser.mly"
      ( END_PAIRED )
# 604 "atkifparser.ml"
               : 'maybe_paired))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'general) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'key) in
    Obj.repr(
# 158 "atkifparser.mly"
                                        ( string_of_ciphered (string_of_general _2) _5 )
# 612 "atkifparser.ml"
               : 'maybe_ciphered))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 159 "atkifparser.mly"
           ( _1 )
# 619 "atkifparser.ml"
               : 'maybe_ciphered))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'args) in
    Obj.repr(
# 163 "atkifparser.mly"
              ( string_of_function _1 _2 )
# 627 "atkifparser.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string*int) in
    Obj.repr(
# 164 "atkifparser.mly"
               ( string_of_nonce _1 )
# 634 "atkifparser.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string*int) in
    Obj.repr(
# 165 "atkifparser.mly"
              ( string_of_free _1 )
# 641 "atkifparser.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string*int) in
    Obj.repr(
# 166 "atkifparser.mly"
               ( string_of_nonce _1 )
# 648 "atkifparser.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string*int) in
    Obj.repr(
# 167 "atkifparser.mly"
              ( string_of_free _1 )
# 655 "atkifparser.ml"
               : 'term))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'general) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'more_args) in
    Obj.repr(
# 171 "atkifparser.mly"
                                   ( ARG ((string_of_general _2)^_3) )
# 663 "atkifparser.ml"
               : 'args))
; (fun __caml_parser_env ->
    Obj.repr(
# 172 "atkifparser.mly"
       ( CONST )
# 669 "atkifparser.ml"
               : 'args))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'general) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'more_args) in
    Obj.repr(
# 176 "atkifparser.mly"
                         ( ","^(string_of_general _2)^_3 )
# 677 "atkifparser.ml"
               : 'more_args))
; (fun __caml_parser_env ->
    Obj.repr(
# 177 "atkifparser.mly"
     ( "" )
# 683 "atkifparser.ml"
               : 'more_args))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 181 "atkifparser.mly"
        ( _1 )
# 690 "atkifparser.ml"
               : 'key))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'general) in
    Obj.repr(
# 182 "atkifparser.mly"
                          ( (string_of_general _2) )
# 697 "atkifparser.ml"
               : 'key))
(* Entry avispa_output *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let avispa_output (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : string)
